//+------------------------------------------------------------------+
//|                                                             .mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
#property copyright "Jon Katana programm by olyakish"
extern int Step=100;
double Equity=0;
double price_1=0.0,price_2=0.0,price_a=0.0,price_b=0.0;

int mag_SL1=101,mag_SL2=103,mag_BL1=102,mag_BL2=104,mag_BS=105,mag_SS=106;
bool need_SL1=true,need_SL2=true,need_BL1=true,need_BL2=true,need_BS=true,need_SS=true;
bool new_cucle=true;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void   OnTick()
  {
   if(new_cucle)
     {
      price_2=Bid+1.5*Step*Point;
      price_1=Bid+0.5*Step*Point;
      price_a=Bid-0.5*Step*Point;
      price_b=Bid-1.5*Step*Point;
      new_cucle=false;
      need_SL1=true;need_SL2=true;need_BL1=true;need_BL2=true;need_BS=true;need_SS=true;
     }


   if(Bid>price_2)
     {
      //  BS, SL1, SL2, BL2
      if(!need_BS){(0,mag_BS);}
      if(!need_SL1){(1,mag_SL1);}
      if(!need_SL2){(1,mag_SL2);}
      if(!need_BL2){(0,mag_BL2);}
      new_cucle=true;
     }
   if(Bid>price_1)
     {
      //  SL1, SL2, BS
      //  BL1, SS
      if(need_SL1){(1,0.1,mag_SL1);need_SL1=false;}
      if(need_SL2){(1,0.1,mag_SL2);need_SL2=false;}
      if(need_BS){(0,0.1,mag_BS);need_BS=false;}
      if(!need_BL1){(0,mag_BL1);}
      if(!need_SS){(1,mag_SS);}
      
     }

   if(Bid<price_a)
     {
      //  BL1, BL2, SS
      //  SL1,BS
      if(need_BL1){(0,0.1,mag_BL1);need_BL1=false;}
      if(need_BL2){(0,0.1,mag_BL2);need_BL2=false;}
      if(need_SS){(1,0.1,mag_SS);need_SS=false;}
      if(!need_SL1){(1,mag_SL1);}
      if(!need_BS){(0,mag_BS);}
     }
   if(Bid<price_b)
     {
      //  BL1, SL2, SS, BL2
      if(!need_BL1){(0,mag_BL1);}
      if(!need_SL2){(1,mag_SL2);}
      if(!need_SS){(1,mag_SS);}
      if(!need_BL2){(0,mag_BL2);}
      new_cucle=true;
     }
        Comment("p_2=",price_2,"\np_1=",price_1,"\np_a=",price_a,"\np_b=",price_b);
   return;

  }
//+------------------------------------------------------------------+
bool (int type,int magic)
  {
   double lotClose=0.0;
   if(OrdersTotal()!=0) //     
     {
      for(int i=OrdersTotal()-1;i>=0;i--)
        {
         RefreshRates();
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()==type && OrderMagicNumber()==magic && OrderSymbol()==Symbol() && type==OP_BUY)
           {
            OrderClose(OrderTicket(),OrderLots(),Bid,5,Lime);
           }
         if(OrderType()==type && OrderMagicNumber()==magic && OrderSymbol()==Symbol() && type==OP_SELL)
           {
            OrderClose(OrderTicket(),OrderLots(),Ask,5,Lime);
           }
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+

bool (int type,double inLot,int mag)
  {
   double pr_open=0.0;
   if(!IsTradeContextBusy())
     {
      RefreshRates();
      if(type==0){pr_open=NormalizeDouble(Ask,Digits);}
      if(type==1){pr_open=NormalizeDouble(Bid,Digits);}

      int globalTicket=OrderSend(Symbol(),type,inLot,pr_open,0,0.0,0.0,(string)mag,mag,0,DarkOrange);
      if(globalTicket<0){Print("  ",GetLastError());}
      Print (globalTicket," ",mag);
     }
   return(0);
  }
//+------------------------------------------------------------------+
